/*++

Copyright (c) 2009
Lysann Kessler, Stephanie Platz, Thomas Klingbeil, Philipp Tessenow, Frank Schlegel;
Michael Haupt, Michael Perscheid, Robert Hirschfeld;
Software Architecture Group, Hasso-Plattner-Institut, University of Potsdam, Germany

This software is published under MIT license.
It uses phidget library by Phidgets Inc. (http://phidgets.com).
See ../../../../license.pdf for more information.

--*/

#ifndef _XMUTEXT_H_
#define _XMUTEXT_H_

// include OS specific mutex headers, definitions, ...
#ifdef _WINDOWS

#include <Windows.h>
typedef CRITICAL_SECTION	xmutex_t;

#else // _WINDOWS

#include <pthread.h>
typedef pthread_mutex_t		xmutex_t;

#endif // _WINDOWS

//////////////////////////////////////////////////////////////////////////
// types

// boolean
#ifndef BOOL
#define BOOL	int
#endif
#ifndef TRUE
#define TRUE	1
#endif
#ifndef FALSE
#define FALSE	0
#endif


//////////////////////////////////////////////////////////////////////////
// function declarations

BOOL xmutex_create(xmutex_t* pMutex);
BOOL xmutex_destroy(xmutex_t* pMutex);
BOOL xmutex_lock(xmutex_t* pMutex);
BOOL xmutex_unlock(xmutex_t* pMutex);


#endif //_XMUTEXT_H_
